// Copyright 2022 The Accumulate Authors
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

package staking

// GENERATED BY go run ./tools/cmd/gen-types. DO NOT EDIT.

import (
	"encoding/json"
	"fmt"
)

// NewAction creates a new Action for the specified ActionType.
func NewAction(typ ActionType) (Action, error) {
	switch typ {
	case ActionTypeAddAccount:
		return new(AddAccount), nil
	case ActionTypeCancelRequest:
		return new(CancelRequest), nil
	case ActionTypeChangeDelegate:
		return new(ChangeDelegate), nil
	case ActionTypeChangeDelegatorPayout:
		return new(ChangeDelegatorPayout), nil
	case ActionTypeChangePayout:
		return new(ChangePayout), nil
	case ActionTypeChangeType:
		return new(ChangeType), nil
	case ActionTypeRegisterIdentity:
		return new(RegisterIdentity), nil
	case ActionTypeRejectDelegates:
		return new(RejectDelegates), nil
	case ActionTypeTransferTokens:
		return new(TransferTokens), nil
	case ActionTypeUnstakeAccount:
		return new(UnstakeAccount), nil
	case ActionTypeWithdrawTokens:
		return new(WithdrawTokens), nil
	}
	return nil, fmt.Errorf("unknown action %v", typ)
}

// EqualAction is used to compare the values of the union
func EqualAction(a, b Action) bool {
	if a == b {
		return true
	}
	switch a := a.(type) {
	case *AddAccount:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*AddAccount)
		return ok && a.Equal(b)
	case *CancelRequest:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*CancelRequest)
		return ok && a.Equal(b)
	case *ChangeDelegate:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*ChangeDelegate)
		return ok && a.Equal(b)
	case *ChangeDelegatorPayout:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*ChangeDelegatorPayout)
		return ok && a.Equal(b)
	case *ChangePayout:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*ChangePayout)
		return ok && a.Equal(b)
	case *ChangeType:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*ChangeType)
		return ok && a.Equal(b)
	case *RegisterIdentity:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*RegisterIdentity)
		return ok && a.Equal(b)
	case *RejectDelegates:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*RejectDelegates)
		return ok && a.Equal(b)
	case *TransferTokens:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*TransferTokens)
		return ok && a.Equal(b)
	case *UnstakeAccount:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*UnstakeAccount)
		return ok && a.Equal(b)
	case *WithdrawTokens:
		if a == nil {
			return b == nil
		}
		b, ok := b.(*WithdrawTokens)
		return ok && a.Equal(b)
	}
	return false
}

// CopyAction copies a Action.
func CopyAction(v Action) Action {
	switch v := v.(type) {
	case *AddAccount:
		return v.Copy()
	case *CancelRequest:
		return v.Copy()
	case *ChangeDelegate:
		return v.Copy()
	case *ChangeDelegatorPayout:
		return v.Copy()
	case *ChangePayout:
		return v.Copy()
	case *ChangeType:
		return v.Copy()
	case *RegisterIdentity:
		return v.Copy()
	case *RejectDelegates:
		return v.Copy()
	case *TransferTokens:
		return v.Copy()
	case *UnstakeAccount:
		return v.Copy()
	case *WithdrawTokens:
		return v.Copy()
	default:
		return v.CopyAsInterface().(Action)
	}
}

// UnmarshalActionJson unmarshals a Action.
func UnmarshalActionJSON(data []byte) (Action, error) {
	var typ *struct{ ActionType ActionType }
	err := json.Unmarshal(data, &typ)
	if err != nil {
		return nil, err
	}

	if typ == nil {
		return nil, nil
	}

	acnt, err := NewAction(typ.ActionType)
	if err != nil {
		return nil, err
	}

	err = json.Unmarshal(data, acnt)
	if err != nil {
		return nil, err
	}

	return acnt, nil
}
